#pragma semicolon 1
#include <sourcemod>

public Plugin:myinfo = 
{
	name	= "Folder View",
	author	= "wS / Schmidt",
	version	= "1.0",
	url		= "http://world-source.ru/"
};

public OnPluginStart()
{
	RegAdminCmd("folder_view", folder_view, ADMFLAG_ROOT);
}

public Action:folder_view(client, args)
{
	if (args != 1)
	{
		PrintToConsole(client, "Syntax: folder_view \"path to folder\"");
		return Plugin_Handled;
	}

	//    .  1   2 .
	static last_time = 0;
	new curr_time = GetTime();
	if (last_time == 0) last_time = curr_time;
	else if ((curr_time - last_time) <= 2)
	{
		PrintToConsole(client, "Pls wait");
		return Plugin_Handled;
	}
	last_time = curr_time;

	decl String:Directory[256]; GetCmdArg(1, Directory, 256);
	ReplaceString(Directory, 256, "\\", "/");
	new symbols = strlen(Directory);
	if (Directory[symbols - 1] == '/') Directory[symbols - 1] = '\0';
	wS_FolderView(client, Directory);

	return Plugin_Handled;
}

wS_FolderView(client, const String:Directory[])
{
	new Handle:dir = OpenDirectory(Directory);
	if (dir == INVALID_HANDLE)
		return;

	decl String:Path[512], String:Info[256];

	decl FileType:type;
	while (ReadDirEntry(dir, Info, 256, type))
	{
		if (type == FileType_Unknown)
			continue;

		if (strcmp(Info, ".") == 0 || strcmp(Info, "..") == 0 || StrContains(Info, ".ztmp", false) > 0)
			continue;

		PrintToConsole(client, "%s/%s", Directory, Info);
		if (type == FileType_Directory)
		{
			Path[0] = '\0'; Format(Path, 512, "%s/%s", Directory, Info);
			wS_FolderView(client, Path);
		}
	}

	CloseHandle(dir);
}